#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2600three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three26004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three26004xi = {
                1:'0x2523y-625z',
                2:'103x680y-2507z',
                3:'1043x2343y-421z',
                4:'104x2063y-1738z',
                5:'1062x1847y-1488z',
                6:'1062x2177y-942z',
                7:'1073x2020y-1234z',
                8:'109x96y-2595z',
                9:'1166x1802y-1467z',
                10:'1166x2289y-395z',
                11:'1179x2127y-918z',
                12:'1183x1972y-1211z',
                13:'123x256y-2584z',
                14:'1267x1750y-1445z',
                15:'1286x2228y-370z',
                16:'1292x1917y-1188z',
                17:'1293x2070y-894z',
                18:'132x2526y-599z',
                19:'134x106y-2594z',
                20:'1366x1692y-1423z',
                21:'1397x1856y-1165z',
                22:'1403x2161y-344z',
                23:'1405x2007y-869z',
                24:'144x698y-2500z',
                25:'1462x1629y-1402z',
                26:'149x272y-2581z',
                27:'1500x1790y-1142z',
                28:'1513x1937y-845z',
                29:'1516x2087y-318z',
                30:'151x2176y-1413z',
                31:'1555x1560y-1380z',
                32:'1599x1717y-1118z',
                33:'160x114y-2592z',
                34:'1618x1862y-820z',
                35:'1625x2007y-292z',
                36:'1645x1486y-1358z',
                37:'1695x1638y-1095z',
                38:'1719x1780y-795z',
                39:'1730x1921y-266z',
                40:'1731x1406y-1335z',
                41:'176x286y-2578z',
                42:'1787x1555y-1071z',
                43:'17x128y-2596z',
                44:'1813x1321y-1313z',
                45:'1816x1693y-770z',
                46:'1830x1830y-240z',
                47:'1874x1465y-1047z',
                48:'187x714y-2492z',
                49:'1907x1600y-746z',
                50:'1925x1733y-215z',
                51:'1956x1371y-1023z',
                52:'1995x1503y-721z',
                53:'2015x1631y-189z',
                54:'204x2342y-1109z',
                55:'206x1995y-1654z',
                56:'206x297y-2574z',
                57:'2076x1400y-696z',
                58:'2099x1525y-163z',
                59:'231x727y-2485z',
                60:'237x307y-2570z',
                61:'24x33y-2599z',
                62:'265x2521y-574z',
                63:'266x2179y-1391z',
                64:'269x313y-2566z',
                65:'278x737y-2477z',
                66:'28x152y-2595z',
                67:'29x637y-2520z',
                68:'2x77y-2598z',
                69:'303x317y-2562z',
                70:'313x1997y-1633z',
                71:'326x744y-2469z',
                72:'328x2339y-1086z',
                73:'338x319y-2558z',
                74:'36x2167y-1435z',
                75:'373x317y-2553z',
                76:'375x748y-2461z',
                77:'382x2176y-1369z',
                78:'397x2510y-549z',
                79:'410x312y-2548z',
                80:'420x1994y-1613z',
                81:'426x749y-2452z',
                82:'42x176y-2593z',
                83:'43x52y-2599z',
                84:'447x305y-2542z',
                85:'452x2329y-1062z',
                86:'478x746y-2444z',
                87:'499x2166y-1347z',
                88:'528x1985y-1593z',
                89:'529x2491y-523z',
                90:'531x740y-2435z',
                91:'576x2312y-1038z',
                92:'584x730y-2425z',
                93:'59x198y-2591z',
                94:'615x2150y-1325z',
                95:'636x1970y-1572z',
                96:'637x716y-2416z',
                97:'63x68y-2598z',
                98:'65x660y-2513z',
                99:'660x2464y-498z',
                100:'691x699y-2406z',
                101:'699x2289y-1014z',
                102:'731x2127y-1302z',
                103:'744x1948y-1551z',
                104:'744x678y-2396z',
                105:'78x219y-2589z',
                106:'790x2431y-472z',
                107:'797x653y-2386z',
                108:'81x2338y-1133z',
                109:'822x2258y-990z',
                110:'846x2098y-1280z',
                111:'850x625y-2376z',
                112:'851x1921y-1530z',
                113:'85x83y-2597z',
                114:'8x103y-2597z',
                115:'8x12y-2599z',
                116:'901x592y-2365z',
                117:'917x2391y-447z',
                118:'943x2221y-966z',
                119:'957x1887y-1509z',
                120:'960x2062y-1257z',
                121:'99x239y-2587z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2600three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2600THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2600THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three26004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three26004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three26004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2600THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                